diff --git a/libavfilter/convolution.h b/libavfilter/convolution.h
index 88aabe9a20..143b0fb2d9 100644
--- a/libavfilter/convolution.h
+++ b/libavfilter/convolution.h
@@ -61,4 +61,6 @@ typedef struct ConvolutionContext {
 } ConvolutionContext;
 
 void ff_convolution_init_x86(ConvolutionContext *s);
+void ff_sobel_init_x86(ConvolutionContext *s);
+int ff_filter_param_init(AVFilterContext *ctx);
 #endif
diff --git a/libavfilter/vf_convolution.c b/libavfilter/vf_convolution.c
index 9a9c099e6d..98aa952258 100644
--- a/libavfilter/vf_convolution.c
+++ b/libavfilter/vf_convolution.c
@@ -874,6 +874,9 @@ static int param_init(AVFilterContext *ctx)
         if (s->depth > 8)
             for (p = 0; p < s->nb_planes; p++)
                 s->filter[p] = filter16_sobel;
+#if CONFIG_CONVOLUTION_FILTER && ARCH_X86_64
+        ff_sobel_init_x86(s);
+#endif
     } else if (!strcmp(ctx->filter->name, "kirsch")) {
         if (s->depth > 8)
             for (p = 0; p < s->nb_planes; p++)
@@ -887,6 +890,11 @@ static int param_init(AVFilterContext *ctx)
     return 0;
 }
 
+int ff_filter_param_init(AVFilterContext *ctx)
+{
+    return param_init(ctx);
+}
+
 static int config_input(AVFilterLink *inlink)
 {
     AVFilterContext *ctx = inlink->dst;
diff --git a/libavfilter/x86/vf_convolution.asm b/libavfilter/x86/vf_convolution.asm
index 754d4d1064..59c807b218 100644
--- a/libavfilter/x86/vf_convolution.asm
+++ b/libavfilter/x86/vf_convolution.asm
@@ -22,6 +22,10 @@
 
 SECTION_RODATA
 half:   dd 0.5
+data_p1: dd  1
+data_n1: dd -1
+data_p2: dd  2
+data_n2: dd -2
 
 SECTION .text
 
@@ -154,3 +158,161 @@ cglobal filter_3x3, 4, 15, 7, dst, width, rdiv, bias, matrix, ptr, c0, c1, c2, c
 INIT_XMM sse4
 FILTER_3X3
 %endif
+
+
+%macro SOBEL_MUL_16 3
+    movd xmm2, [%2]
+    VPBROADCASTD m2, xmm2
+    movdqu xmm3, [c%1q + xq]
+    vpmovzxbd m3, xmm3
+    vpdpbusd  m%3, m3, m2
+%endmacro
+
+%macro SOBEL_ADD_16 2
+    movdqu xmm3, [c%1q + xq]
+    vpmovzxbd m3, xmm3
+    vpaddd  m%2, m3
+%endmacro
+
+
+%macro SOBEL_MUL 2
+    movzx ptrd, byte [c%1q + xq]
+    imul  ptrd, [%2]
+    add   rd, ptrd
+%endmacro
+
+%macro SOBEL_ADD 1
+    movzx ptrd, byte [c%1q + xq]
+    add   rd, ptrd
+%endmacro
+
+; void filter_sobel_avx512(uint8_t *dst, int width,
+;                      float scale, float delta, const int *const matrix,
+;                      const uint8_t *c[], int peak, int radius,
+;                      int dstride, int stride)
+%macro FILTER_SOBEL 0
+%if UNIX64
+cglobal filter_sobel, 4, 15, 7, dst, width, matrix, ptr, c0, c1, c2, c3, c4, c5, c6, c7, c8, r, x
+%else
+cglobal filter_sobel, 4, 15, 7, dst, width, rdiv, bias, matrix, ptr, c0, c1, c2, c3, c4, c5, c6, c7, c8, r, x
+%endif
+%if WIN64
+    SWAP xmm0, xmm2
+    SWAP xmm1, xmm3
+    mov  r2q, matrixmp
+    mov  r3q, ptrmp
+    DEFINE_ARGS dst, width, matrix, ptr, c0, c1, c2, c3, c4, c5, c6, c7, c8, r, x
+%endif
+    movsxdifnidn widthq, widthd
+    VBROADCASTSS m0, xmm0
+    VBROADCASTSS m1, xmm1
+    pxor  m6, m6
+    mov   c0q, [ptrq + 0*gprsize]
+    mov   c1q, [ptrq + 1*gprsize]
+    mov   c2q, [ptrq + 2*gprsize]
+    mov   c3q, [ptrq + 3*gprsize]
+    mov   c4q, [ptrq + 4*gprsize]
+    mov   c5q, [ptrq + 5*gprsize]
+    mov   c6q, [ptrq + 6*gprsize]
+    mov   c7q, [ptrq + 7*gprsize]
+    mov   c8q, [ptrq + 8*gprsize]
+
+    xor   xq, xq
+    cmp   widthq, mmsize/4
+    jl .loop2
+
+    mov   rq, widthq
+    and   rq, mmsize/4-1
+    sub   widthq, rq
+
+.loop1:
+    pxor m4, m4         
+    pxor m5, m5         
+
+    ;Gx
+    SOBEL_MUL_16 0, data_n1, 4
+    SOBEL_MUL_16 1, data_n2, 4
+    SOBEL_MUL_16 2, data_n1, 4
+    SOBEL_ADD_16 6, 4
+    SOBEL_MUL_16 7, data_p2, 4
+    SOBEL_ADD_16 8, 4
+
+    cvtdq2ps  m4, m4
+    mulps     m4, m4
+
+    ;Gy
+    SOBEL_MUL_16 0, data_n1, 5
+    SOBEL_ADD_16 2, 5
+    SOBEL_MUL_16 3, data_n2, 5
+    SOBEL_MUL_16 5, data_p2, 5
+    SOBEL_MUL_16 6, data_n1, 5
+    SOBEL_ADD_16 8, 5
+
+    cvtdq2ps    m5, m5
+    VFMADD231PS m4, m5, m5
+
+    sqrtps    m4, m4
+    mulps     m4, m0       ; sum *= scale
+    addps     m4, m1       ; sum += delta
+    cvttps2dq m4, m4
+    vpmovusdb xmm4, m4
+    movdqu    [dstq + xq], xmm4
+
+    add xq, mmsize/4
+    cmp xq, widthq
+    jl .loop1
+
+    add widthq, rq
+    cmp xq, widthq
+    jge .end
+
+.loop2:
+    xor  rd, rd
+    pxor m4, m4
+
+    ;Gx
+    SOBEL_MUL 0, data_n1
+    SOBEL_MUL 1, data_n2
+    SOBEL_MUL 2, data_n1
+    SOBEL_ADD 6
+    SOBEL_MUL 7, data_p2
+    SOBEL_ADD 8
+
+    cvtsi2ss xmm4, rd
+    mulss    xmm4, xmm4
+
+    xor rd, rd
+    ;Gy
+    SOBEL_MUL 0, data_n1
+    SOBEL_ADD 2
+    SOBEL_MUL 3, data_n2
+    SOBEL_MUL 5, data_p2
+    SOBEL_MUL 6, data_n1
+    SOBEL_ADD 8
+
+    cvtsi2ss  xmm5, rd
+    mulss     xmm5, xmm5    ; b1 * b1
+    addss     xmm4, xmm5
+
+    sqrtps    xmm4, xmm4
+    mulss     xmm4, xmm0     ; sum *= rdiv
+    addss     xmm4, xmm1     ; sum += bias
+    cvttps2dq xmm4, xmm4     ; trunc to integer
+    packssdw  xmm4, xmm4
+    packuswb  xmm4, xmm4
+    movd      rd, xmm4
+    mov       [dstq + xq], rb
+
+    add xq, 1
+    cmp xq, widthq
+    jl .loop2
+.end:
+    RET
+%endmacro
+
+%if ARCH_X86_64
+%if HAVE_AVX512ICL_EXTERNAL
+INIT_ZMM avx512icl
+FILTER_SOBEL
+%endif
+%endif
diff --git a/libavfilter/x86/vf_convolution_init.c b/libavfilter/x86/vf_convolution_init.c
index b78a47d02b..52a3d28991 100644
--- a/libavfilter/x86/vf_convolution_init.c
+++ b/libavfilter/x86/vf_convolution_init.c
@@ -29,6 +29,11 @@ void ff_filter_3x3_sse4(uint8_t *dst, int width,
                         const uint8_t *c[], int peak, int radius,
                         int dstride, int stride, int size);
 
+void ff_filter_sobel_avx512icl(uint8_t *dst, int width,
+                         float scale, float delta, const int *const matrix,
+                         const uint8_t *c[], int peak, int radius,
+                         int dstride, int stride, int size);
+
 av_cold void ff_convolution_init_x86(ConvolutionContext *s)
 {
 #if ARCH_X86_64
@@ -44,3 +49,16 @@ av_cold void ff_convolution_init_x86(ConvolutionContext *s)
     }
 #endif
 }
+
+av_cold void ff_sobel_init_x86(ConvolutionContext *s)
+{
+#if ARCH_X86_64
+    int cpu_flags = av_get_cpu_flags();
+    for (int i = 0; i < s->nb_planes; i++) {
+        if (s->depth == 8) {
+            if (EXTERNAL_AVX512ICL(cpu_flags))
+                s->filter[i] = ff_filter_sobel_avx512icl;
+        }
+    }
+#endif
+}
diff --git a/tests/checkasm/Makefile b/tests/checkasm/Makefile
index 1ac170491b..4e91547fde 100644
--- a/tests/checkasm/Makefile
+++ b/tests/checkasm/Makefile
@@ -44,6 +44,7 @@ AVFILTEROBJS-$(CONFIG_GBLUR_FILTER)      += vf_gblur.o
 AVFILTEROBJS-$(CONFIG_HFLIP_FILTER)      += vf_hflip.o
 AVFILTEROBJS-$(CONFIG_THRESHOLD_FILTER)  += vf_threshold.o
 AVFILTEROBJS-$(CONFIG_NLMEANS_FILTER)    += vf_nlmeans.o
+AVFILTEROBJS-$(CONFIG_CONVOLUTION_FILTER)    += vf_convolution.o
 
 CHECKASMOBJS-$(CONFIG_AVFILTER) += $(AVFILTEROBJS-yes)
 
diff --git a/tests/checkasm/checkasm.c b/tests/checkasm/checkasm.c
index e56fd3850e..ae5e9d1143 100644
--- a/tests/checkasm/checkasm.c
+++ b/tests/checkasm/checkasm.c
@@ -191,6 +191,9 @@ static const struct {
     #if CONFIG_THRESHOLD_FILTER
         { "vf_threshold", checkasm_check_vf_threshold },
     #endif
+    #if CONFIG_CONVOLUTION_FILTER
+        { "vf_convolution", checkasm_check_vf_convolution },
+    #endif
 #endif
 #if CONFIG_SWSCALE
     { "sw_gbrp", checkasm_check_sw_gbrp },
diff --git a/tests/checkasm/checkasm.h b/tests/checkasm/checkasm.h
index d7645d3730..71c722cf77 100644
--- a/tests/checkasm/checkasm.h
+++ b/tests/checkasm/checkasm.h
@@ -85,6 +85,7 @@ void checkasm_check_vf_eq(void);
 void checkasm_check_vf_gblur(void);
 void checkasm_check_vf_hflip(void);
 void checkasm_check_vf_threshold(void);
+void checkasm_check_vf_convolution(void);
 void checkasm_check_vp8dsp(void);
 void checkasm_check_vp9dsp(void);
 void checkasm_check_videodsp(void);
diff --git a/tests/checkasm/vf_convolution.c b/tests/checkasm/vf_convolution.c
new file mode 100644
index 0000000000..353b32af5b
--- /dev/null
+++ b/tests/checkasm/vf_convolution.c
@@ -0,0 +1,116 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with FFmpeg; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#include <string.h>
+#include "checkasm.h"
+#include "libavfilter/avfilter.h"
+#include "libavfilter/convolution.h"
+#include "libavutil/intreadwrite.h"
+#include "libavutil/mem_internal.h"
+
+#define WIDTH 512
+#define HEIGHT 512
+#define SRC_STRIDE 512
+#define PIXELS (WIDTH * HEIGHT)
+
+#define randomize_buffers(buf, size)      \
+    do {                                  \
+        int j;                            \
+        uint8_t *tmp_buf = (uint8_t *)buf;\
+        for (j = 0; j< size; j++)         \
+            tmp_buf[j] = rnd() & 0xFF;    \
+    } while (0)
+
+static void check_sobel(const char * report_name)
+{
+    LOCAL_ALIGNED_32(uint8_t, src,     [PIXELS]);
+    LOCAL_ALIGNED_32(uint8_t, dst_ref, [PIXELS]);
+    LOCAL_ALIGNED_32(uint8_t, dst_new, [PIXELS]);
+    const int height = WIDTH;
+    const int width  = HEIGHT;
+    const int stride = SRC_STRIDE;
+    const int dstride = SRC_STRIDE;
+    int mode = 0;
+    const uint8_t *c[49];
+    const int radius = 1;
+    const int bpc = 1;
+    const int step = mode == MATRIX_COLUMN ? 16 : 1;
+    const int slice_start = 0;
+    const int slice_end = height;
+    int y;
+    const int sizew = mode == MATRIX_COLUMN ? height : width;
+
+    AVFilterContext *filter_in, *filter_sobel;
+    AVFilterGraph *filter_graph;
+    AVFilterLink *inlink;
+    ConvolutionContext *s;
+    char args[255];
+    
+    filter_graph = avfilter_graph_alloc();
+    snprintf(args, sizeof(args), "video_size=%dx%d:pix_fmt=%d:time_base=%d/%d:pixel_aspect=%d/%d", WIDTH, HEIGHT, AV_PIX_FMT_YUV420P, 1, 1, 1, 1);
+    avfilter_graph_create_filter(&filter_in, avfilter_get_by_name("buffer"), "in", args, NULL, filter_graph);
+    avfilter_graph_create_filter(&filter_sobel, avfilter_get_by_name(report_name), NULL, NULL, NULL, filter_graph);
+    avfilter_link(filter_in, 0, filter_sobel, 0);
+
+    inlink = filter_sobel->inputs[0];
+    inlink->format = AV_PIX_FMT_YUV420P;
+    ff_filter_param_init(filter_sobel);
+    s = filter_sobel->priv;
+
+    declare_func(void, uint8_t *dst, int width, float scale, float delta, const int *const matrix,
+                 const uint8_t *c[], int peak, int radius, int dstride, int stride, int size);
+
+    float scale = 2;
+    float delta = 10;
+
+    memset(dst_ref, 0, PIXELS);
+    memset(dst_new, 0, PIXELS);
+    randomize_buffers(src, PIXELS);
+
+    if (check_func(s->filter[0], "%s", report_name)) {
+        for (y = slice_start; y < slice_end; y += step) {
+            const int xoff = mode == MATRIX_COLUMN ? (y - slice_start) * bpc : radius * bpc;
+            const int yoff = mode == MATRIX_COLUMN ? radius * dstride : 0;
+
+            s->setup[0](radius, c, src, stride, radius, width, y, height, bpc);
+            call_ref(dst_ref + yoff + xoff, sizew - 2 * radius,
+                     scale, delta, NULL, c, 0, radius,
+                     dstride, stride, slice_end - step);
+            call_new(dst_new + yoff + xoff, sizew - 2 * radius,
+                     scale, delta, NULL, c, 0, radius,
+                     dstride, stride, slice_end - step);
+            if (memcmp(dst_ref + yoff + xoff, dst_new + yoff + xoff, slice_end - step))
+                fail();
+            bench_new(dst_new + yoff + xoff, sizew - 2 * radius,
+                      scale, delta, NULL, c, 0, radius,
+                      dstride, stride, slice_end - step);
+            if (mode != MATRIX_COLUMN)
+                dst_ref += dstride;
+        }
+    }
+
+    avfilter_free(filter_in);
+    avfilter_free(filter_sobel);
+    avfilter_graph_free(&filter_graph);
+}
+
+void checkasm_check_vf_convolution(void)
+{
+    check_sobel("sobel");
+    report("convolution:sobel");
+}